'use babel';

import SelectSimilarRclick from '../lib/select-similar-rclick';

// Use the command `window:run-package-specs` (cmd-alt-ctrl-p) to run specs.
//
// To run a specific `it` or `describe` block add an `f` to the front (e.g. `fit`
// or `fdescribe`). Remove the `f` to unfocus the block.

describe('SelectSimilarRclick', () => {
  let workspaceElement, activationPromise;

  beforeEach(() => {
    workspaceElement = atom.views.getView(atom.workspace);
    activationPromise = atom.packages.activatePackage('select-similar-rclick');
  });

  describe('when the select-similar-rclick:toggle event is triggered', () => {
    it('hides and shows the modal panel', () => {
      // Before the activation event the view is not on the DOM, and no panel
      // has been created
      expect(workspaceElement.querySelector('.select-similar-rclick')).not.toExist();

      // This is an activation event, triggering it will cause the package to be
      // activated.
      atom.commands.dispatch(workspaceElement, 'select-similar-rclick:toggle');

      waitsForPromise(() => {
        return activationPromise;
      });

      runs(() => {
        expect(workspaceElement.querySelector('.select-similar-rclick')).toExist();

        let selectSimilarRclickElement = workspaceElement.querySelector('.select-similar-rclick');
        expect(selectSimilarRclickElement).toExist();

        let selectSimilarRclickPanel = atom.workspace.panelForItem(selectSimilarRclickElement);
        expect(selectSimilarRclickPanel.isVisible()).toBe(true);
        atom.commands.dispatch(workspaceElement, 'select-similar-rclick:toggle');
        expect(selectSimilarRclickPanel.isVisible()).toBe(false);
      });
    });

    it('hides and shows the view', () => {
      // This test shows you an integration test testing at the view level.

      // Attaching the workspaceElement to the DOM is required to allow the
      // `toBeVisible()` matchers to work. Anything testing visibility or focus
      // requires that the workspaceElement is on the DOM. Tests that attach the
      // workspaceElement to the DOM are generally slower than those off DOM.
      jasmine.attachToDOM(workspaceElement);

      expect(workspaceElement.querySelector('.select-similar-rclick')).not.toExist();

      // This is an activation event, triggering it causes the package to be
      // activated.
      atom.commands.dispatch(workspaceElement, 'select-similar-rclick:toggle');

      waitsForPromise(() => {
        return activationPromise;
      });

      runs(() => {
        // Now we can test for view visibility
        let selectSimilarRclickElement = workspaceElement.querySelector('.select-similar-rclick');
        expect(selectSimilarRclickElement).toBeVisible();
        atom.commands.dispatch(workspaceElement, 'select-similar-rclick:toggle');
        expect(selectSimilarRclickElement).not.toBeVisible();
      });
    });
  });
});
